---
title: IDBCursor.update()
slug: Web/API/IDBCursor/update
tags:
  - API
  - Database
  - IDBCursor
  - IndexedDB
  - Method
  - Reference
  - Storage
  - Update
---
<div>{{APIRef("IndexedDB")}}</div>

<p>The <strong><code>update()</code></strong> method of the {{domxref("IDBCursor")}} interface returns an {{domxref("IDBRequest")}} object, and, in a separate thread, updates the value at the current position of the cursor in the object store. If the cursor points to a record that has just been deleted, a new record is created.</p>

<p>Be aware that you can't call <code>update()</code> (or {{domxref("IDBCursor.delete()")}}) on cursors obtained from {{domxref("IDBIndex.openKeyCursor()")}}. For such needs, you have to use {{domxref("IDBIndex.openCursor()")}} instead.</p>

<p>{{AvailableInWorkers}}</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <em>anIDBRequest</em> = <em>myIDBCursor</em>.update(<em>value</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>value</dt>
 <dd>The new value to be stored at the current position.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>An {{domxref("IDBRequest")}} object on which subsequent events related to this operation are fired.</p>

<h3 id="Exceptions">Exceptions</h3>

<p>This method may raise a {{domxref("DOMException")}} of one of the following types:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Exception</th>
   <th scope="col">Description</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>TransactionInactiveError</code></td>
   <td>This IDBCursor's transaction is inactive.</td>
  </tr>
  <tr>
   <td><code>ReadOnlyError</code></td>
   <td>The transaction mode is read only.</td>
  </tr>
  <tr>
   <td><code>InvalidStateError</code></td>
   <td>The cursor was created using {{domxref("IDBIndex.openKeyCursor")}}, is currently being iterated, or has iterated past its end.</td>
  </tr>
  <tr>
   <td><code>DataError</code></td>
   <td>
    <p>The underlying object store uses in-line keys and the property in the value at the object store's key path does not match the key in this cursor's position.</p>
   </td>
  </tr>
  <tr>
   <td><code>DataCloneError</code></td>
   <td>The data being stored could not be cloned by the internal structured cloning algorithm.</td>
  </tr>
 </tbody>
</table>

<h2 id="Example">Example</h2>

<p>In this simple fragment we create a transaction, retrieve an object store, then use a cursor to iterate through all the records in the object store. If the <code>albumTitle</code> of the current cursor is "A farewell to kings", we update year the album was released using <code>const request = cursor.update();</code>.</p>

<p>Note that you cannot change primary keys using <code>cursor.update()</code>, hence us not changing the album title; this would ruin the integrity of the data. In such a situation, you would have to delete the record altogether and then add a new one using {{domxref("IDBObjectStore.add")}}. Note also that you can't directly put <code>cursor.value</code> into an update call, hence the below example using an intermediary <code>updateData</code> variable.</p>

<p>T<span style="line-height: 1.5;">he cursor does not require us to select the data based on a key; we can just grab all of it. Also note that in each iteration of the loop, you can grab data from the current record under the cursor object using </span><code style="font-style: normal; line-height: 1.5;">cursor.value.foo</code><span style="line-height: 1.5;">. For a complete working example, see our <a class="external external-icon" href="https://github.com/mdn/indexeddb-examples/tree/master/idbcursor" style="white-space: pre-line;">IDBCursor example</a></span><span style="line-height: 1.5;"> (</span><a class="external external-icon" href="https://mdn.github.io/indexeddb-examples/idbcursor/" style="white-space: pre-line; line-height: 1.5;">view example live</a><span style="line-height: 1.5;">.)</span></p>

<pre class="brush: js notranslate">function updateResult() {
  list.textContent = '';
  const transaction = db.transaction(['rushAlbumList'], 'readwrite');
  const objectStore = transaction.objectStore('rushAlbumList');

  objectStore.openCursor().onsuccess = function(event) {
    const cursor = event.target.result;
    if (cursor) {
      if (cursor.value.albumTitle === 'A farewell to kings') {
        const updateData = cursor.value;

        updateData.year = 2050;
        const request = cursor.update(updateData);
        request.onsuccess = function() {
          console.log('A better album year?');
        };
      };

      const listItem = document.createElement('li');
      listItem.innerHTML = '&lt;strong&gt;' + cursor.value.albumTitle + '&lt;/strong&gt;, ' + cursor.value.year;
      list.appendChild(listItem);
      cursor.continue();
    } else {
      console.log('Entries displayed.');
    }
  };
};</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('IndexedDB', '#dom-idbcursor-update', 'update()')}}</td>
   <td>{{Spec2('IndexedDB')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName("IndexedDB 2", "#dom-idbcursor-update", "update()")}}</td>
   <td>{{Spec2("IndexedDB 2")}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>
<div>

<p>{{Compat("api.IDBCursor.update")}}</p>
</div>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/IndexedDB_API/Using_IndexedDB">Using IndexedDB</a></li>
 <li>Starting transactions: {{domxref("IDBDatabase")}}</li>
 <li>Using transactions: {{domxref("IDBTransaction")}}</li>
 <li>Setting a range of keys: {{domxref("IDBKeyRange")}}</li>
 <li>Retrieving and making changes to your data: {{domxref("IDBObjectStore")}}</li>
 <li>Using cursors: {{domxref("IDBCursor")}}</li>
 <li>Reference example: <a class="external" href="https://github.com/mdn/to-do-notifications/tree/gh-pages">To-do Notifications</a> (<a class="external" href="https://mdn.github.io/to-do-notifications/">view example live</a>.)</li>
</ul>
